<template>
  <div class="wisielec">
    <button @click="handleLogOut()" class="x x-fixed-2">log-out</button>
    <div class="output">
      <img
        v-for="image of images"
        :key="image.index"
        :src="getImgUrl(image.name)"
        :class="{ done: currentLife >= image.index }"
        alt="obrazek"
      />
    </div>
    <div class="password">
      <span
        v-show="leftTrys"
        v-for="(letter, index) of passwordText"
        :key="index"
        >{{ letter }}</span
      >
      <div v-show="!leftTrys">
        <p>Przegrana. Spróbuj ponownie</p>
        <a href="">Okay</a>
      </div>
      <div v-if="winner">
        <p>Gratulację! Udało Ci się odgadnąć hasło</p>
        <a href="">Zagraj jeszcze raz</a>
      </div>
    </div>
    <div class="category" v-if="leftTrys && !winner">
      Kategoria: {{ currentPassword.category }}
    </div>
    <div class="letters" v-if="leftTrys && !winner">
      <button
        v-for="(letter, index) in alphabet"
        :key="`${letter}_index`"
        @click="guessLetter($event)"
        :ref="`${index}`"
      >
        {{ letter }}
      </button>
    </div>
  </div>
</template>

<script>
import * as Keycloak from "keycloak-js";

export default {
  mounted() {
    this.login();
  },
  created() {
    this.currentPassword =
      this.passwords[Math.floor(Math.random() * this.passwords.length)];
    // let passArray = [];
    // for (const letter of this.currentPassword.password) {
    //   passArray.push(letter);
    // }
    // console.log("passArray", passArray);
    // let { password, category } = this.currentPassword;
    // console.log("password", password);
    // console.log("category", category);

    this.passwordText = [...this.currentPassword.password].map((el) => {
      if (el === " ") {
        return " ";
      } else return "_";
    });
  },
  refresh: true,
  name: "WisielecTest",
  data() {
    return {
      alphabet: "AĄBCĆDEĘFGHIJKLŁMNŃOÓPQRSŚTUVWXYZŹŻ",
      passwordText: [],
      currentPassword: {},
      winner: false,
      endgame: false,
      currentLife: 1,
      leftTrys: 7,
      passwords: [
        {
          password: "DUPA DUPA",
          category: "Dupa",
        },
        // {
        //   password: "GRAN TORINO",
        //   category: "Film",
        // },
        // {
        //   password: "PAN TADEUSZ",
        //   category: "Utwór literacki",
        // },
        // {
        //   password: "PAWEŁ SALA",
        //   category: "Kto został wykreowany przez środowisko",
        // },
      ],
      images: [
        {
          name: "1.png",
          index: 1,
        },
        {
          name: "2.png",
          index: 2,
        },
        {
          name: "3.png",
          index: 3,
        },
        {
          name: "4.png",
          index: 4,
        },
        {
          name: "5.png",
          index: 5,
        },
        {
          name: "6.png",
          index: 6,
        },
        {
          name: "7.png",
          index: 7,
        },
        {
          name: "8.png",
          index: 8,
        },
      ],
    };
  },

  methods: {
    getImgUrl(src) {
      var images = require.context("@/assets/images/", false, /\.png$/);
      return images("./" + src);
    },
    guessLetter(e) {
      e.target.setAttribute("disabled", true);
      this.passwordText = this.passwordText.map((item, index) => {
        // let test = this.currentPassword.password[index] === e.target.innerText;
        // console.log("test", test);
        if (this.currentPassword.password[index] === e.target.innerText) {
          return e.target.innerText;
        } else {
          return item;
        }
      });
      if (!this.passwordText.includes(e.target.innerText)) {
        this.currentLife++;
        this.leftTrys--;
      }
      if (this.currentPassword.password === this.passwordText.join("")) {
        this.winner = true;
        this.endgame = true;
      }
    },
    // KEYCLOAK FN

    handleLogOut() {
      const MY_REALM = "test";
      const ENCODED_REDIRECT_URI = `${process.env.VUE_APP_BASE_APP_URL}`;
      window.location.replace(
        `${process.env.VUE_APP_BASE_KEYCLOAK_URL}realms/${MY_REALM}/protocol/openid-connect/logout?redirect_uri=${ENCODED_REDIRECT_URI}`
      );
    },
    login() {
      var keycloak = Keycloak({
        realm: `test`,
        url: `${process.env.VUE_APP_BASE_KEYCLOAK_URL}`,
        clientId: `fantastic-app`,
        "ssl-required": "all",
        resource: `fantastic-app`,
        "public-client": true,
        "confidential-port": 0,
      });
      keycloak
        .init({
          // flow: 'implicit',
          promiseType: "native",
          onLoad: "login-required",
        })
        .then((authenticated) => {
          this.$store.commit("TOKEN_SET", authenticated);
          console.log("TOKEN", authenticated);
          return authenticated;
        })
        .catch((error) => {
          console.error(error);
        });
      keycloak.onTokenExpired = () => {
        keycloak
          .updateToken(30)
          .then((refreshed) => {
            if (refreshed) {
              this.$store.commit("TOKEN_SET", keycloak.token);
            } else {
              console.log("Token is still valid");
            }
          })
          .catch((error) => {
            console.error(error);
          });
      };
    },
  },
};
</script>

<style scoped>
* {
  margin: 0;
  padding: 0;
  box-sizing: border-box;
}

.wisielec {
  width: 860px;
  padding: 60px 30px 0;
  margin: 0 auto;
}

.output {
  display: flex;
}
img {
  opacity: 0.15;
  width: 100px;
}
img.done {
  opacity: 1;
}

.password {
  letter-spacing: 5px;
  font-size: 2rem;
  padding: 30px 20px;
  border: 3px black solid;
}

.category {
  padding: 30px 0px;
}

.letters {
  display: flex;
  flex-wrap: wrap;
  justify-content: center;
}

.letters button {
  font-size: 1.5em;
  font-weight: bold;
  cursor: pointer;
  flex-basis: 80px;
  padding: 10px;
}

.x {
  margin: 8px;
  padding: 8px;
  cursor: pointer;
  font-weight: bold;
  transition: 0.3s;
  background-color: #edd2ff;
  border: 1px solid #000;
  color: black;
}
.x:hover {
  color: white;
  background-color: #3a0061;
}
.x-fixed-2 {
  position: absolute;
  top: 10px;
  right: 10px;
}
</style>
